#include "depend.h"
#include "sound_iocs.h"

// DMA16bitlrbOGfBA(68I[_[)ŏ
#define	DmaPokeW(adrs,data)	(X68SoundIOCS::DmaPoke((adrs),(unsigned int)(data)>>8), \
							 X68SoundIOCS::DmaPoke((adrs)+1, (unsigned int)(data)))
// DMA32bitlrbOGfBA(68I[_[)ŏ
#define	DmaPokeL(adrs,data)	(X68SoundIOCS::DmaPoke((adrs),(unsigned int)(data)>>24), \
							 X68SoundIOCS::DmaPoke((adrs)+1, (unsigned int)(data)>>16), \
							 X68SoundIOCS::DmaPoke((adrs)+2, (unsigned int)(data)>>8), \
							 X68SoundIOCS::DmaPoke((adrs)+3, (unsigned int)(data)))


const static unsigned char	PANTBL[4] = {3, 1, 2, 0};


// 32bitl̃oCg̕тtɂĕԂ
__inline static void *bswapl(void *adrs) {
	void *r;
	__asm {
		mov	eax,adrs
		bswap	eax
		mov r,eax
	}
	return r;
}

// 16bitl̃oCg̕тtɂĕԂ
__inline static unsigned short bswapw(unsigned short data) {
	unsigned short r;
	__asm {
		mov ax,data
		ror ax,8
		mov r,ax
	}
	return r;
}

// OPMBUSY҂
void X68SoundIOCS::OpmWaitBUSY()
{
	while (X68Sound::OpmPeek() & 0x80);
}

// IOCS _OPMSET ($68) ̏
// []
//   int addr : OPMWX^io[(0`255)
//   int data : f[^(0`255)
void X68SoundIOCS::opmset(int addr, int data) {
	if (addr == 0x1B) {
		OpmReg1B = (OpmReg1B&0xC0)|(data&0x3F);
		data = OpmReg1B;
	}
	OpmWaitBUSY();
	X68Sound::OpmReg(addr);
	OpmWaitBUSY();
	X68Sound::OpmPoke(data);
}

// IOCS _OPMSNS ($69) ̏
// [߂l]
//   bit 0 : ^C}[AI[o[t[̂Ƃ1ɂȂ
//   bit 1 : ^C}[BI[o[t[̂Ƃ1ɂȂ
//   bit 7 : 0Ȃ΃f[^݉\
int X68SoundIOCS::opmsns() {
	return X68Sound::OpmPeek();
}

// IOCS _OPMINTST ($6A) ̏
// []
//   void *addr : 荞ݏAhX
//                0̂Ƃ͊荞݋֎~
// [߂l]
//   荞݂ݒ肳ꂽꍇ 0
//   Ɋ荞݂ݒ肳Ăꍇ͂̊荞ݏAhXԂ
int X68SoundIOCS::opmintst(void *addr) {
	if (addr == 0) {				// 0̎͊荞݂֎~
		OpmIntProc = NULL;
		X68Sound::OpmInt(OpmIntProc, OpmIntPara);
		return 0;
	}
	if (OpmIntProc != NULL) {		// ɐݒ肳Ăꍇ́ȀAhXԂ
		return (int)OpmIntProc;
	}
	OpmIntProc = (void (CALLBACK *)(void *))addr;
	X68Sound::OpmInt(OpmIntProc, OpmIntPara);	// OPM̊荞ݏAhXݒ
	return 0;
}

// DMA]I荞ݏ[`
void X68SoundIOCS::DmaIntProc() {
	if (AdpcmStat == 0x32 && (X68Sound::DmaPeek(0x00)&0x40)!=0) {	// ReBj[[h̏
		X68Sound::DmaPoke(0x00, 0x40);	// BTCrbgNA
		if (Adpcmcot_len > 0) {
			int dmalen;
			dmalen = Adpcmcot_len;
			if (dmalen > 0xFF00) {	// 1xɓ]łoCg0xFF00
				dmalen = 0xFF00;
			}
			DmaPokeL(0x1C, Adpcmcot_adrs);	// BARɎDMA]AhXZbg
			DmaPokeW(0x1A, dmalen);	// BTCɎDMA]oCgZbg
			Adpcmcot_adrs += dmalen;
			Adpcmcot_len -= dmalen;

			X68Sound::DmaPoke(0x07, 0x48);	// ReBj[Iy[Vݒ
		}
		return;
	}
	if (!(AdpcmStat&0x80)) {
		X68Sound::PpiCtrl(0x01);	// ADPCMEoOFF
		X68Sound::PpiCtrl(0x03);	// ADPCMoOFF
		X68Sound::AdpcmPoke(0x01);	// ADPCMĐ~
	}
	AdpcmStat = 0;
	X68Sound::DmaPoke(0x00, 0xFF);	// DMA CSR ̑SrbgNA
}

static void CALLBACK DmaIntProc(void *para) {
	X68SoundIOCS *p = (X68SoundIOCS *)para;
	p->DmaIntProc();
}

// DMAG[荞ݏ[`
void X68SoundIOCS::DmaErrIntProc() {
	DmaErrCode = X68Sound::DmaPeek(0x01);	// G[R[h DmaErrCode ɕۑ

	X68Sound::PpiCtrl(0x01);	// ADPCMEoOFF
	X68Sound::PpiCtrl(0x03);	// ADPCMoOFF
	X68Sound::AdpcmPoke(0x01);	// ADPCMĐ~

	AdpcmStat = 0;
	X68Sound::DmaPoke(0x00, 0xFF);	// DMA CSR ̑SrbgNA
}
static void CALLBACK DmaErrIntProc(void *para)
{
	X68SoundIOCS *p = (X68SoundIOCS *)para;
	p->DmaErrIntProc();
}


// TvOgPANݒ肵DMA]Jn郋[`
// []
//   unsigned short mode : TvOg*256+PAN
//   unsigned char ccr : DMA CCR ɏރf[^
void X68SoundIOCS::SetAdpcmMode(unsigned short mode, unsigned char ccr) {
	if (mode >= 0x0200) {
		mode -= 0x0200;
		OpmReg1B &= 0x7F;	// ADPCM̃NbN8MHz
	} else {
		OpmReg1B |= 0x80;	// ADPCM̃NbN4MHz
	}
	OpmWaitBUSY();
	X68Sound::OpmReg(0x1B);
	OpmWaitBUSY();
	X68Sound::OpmPoke(OpmReg1B);	// ADPCM̃NbNݒ(8or4MHz)
	unsigned char ppireg;
	ppireg = ((mode>>6)&0x0C) | PANTBL[mode&3];
	ppireg |= (X68Sound::PpiPeek()&0xF0);
	X68Sound::DmaPoke(0x07, ccr);	// DMA]Jn
	X68Sound::PpiPoke(ppireg);	// TvO[gPANPPIɐݒ
}

// X68SoundIOCS::adpcmout̃C[`
// []
//   unsigned char stat : ADPCM~ɑDMA]sꍇ$80
//                        DMA]IADPCM~ꍇ$00
//   unsigned short len : DMA]oCg
//   unsigned char *adrs : DMA]AhX
void X68SoundIOCS::AdpcmoutMain(unsigned char stat, unsigned short mode, unsigned short len, unsigned char *adrs) {
	while (AdpcmStat);	// DMA]I҂
	AdpcmStat = stat+2;
	X68Sound::DmaPoke(0x05, 0x32);	// DMA OCR `FCȂɐݒ

	X68Sound::DmaPoke(0x00, 0xFF);	// DMA CSR ̑SrbgNA
	DmaPokeL(0x0C, adrs);	// DMA MAR DMA]AhXZbg
	DmaPokeW(0x0A, len);	// DMA MTC DMA]oCgZbg
	SetAdpcmMode(mode, 0x88);	// TvOgPANݒ肵DMA]Jn

	X68Sound::AdpcmPoke(0x02);	// ADPCMĐJn
}

// IOCS _ADPCMOUT ($60) ̏
// []
//   void *addr : ADPCMf[^AhX
//   int mode : TvOg(0`4)*256+PAN(0`3)
//   int len : ADPCMf[^̃oCg
void X68SoundIOCS::adpcmout(void *addr, int mode, int len) {
	int dmalen;
	unsigned char *dmaadrs = (unsigned char *)addr;
	while (AdpcmStat);	// DMA]I҂
	while (len > 0x0000FF00) {	// ADPCMf[^0xFF00oCgȏ̏ꍇ
		dmalen = 0x0000FF00;	// 0xFF00oCgɕDMA]s
		AdpcmoutMain(0x80,mode,dmalen,dmaadrs);
		dmaadrs += dmalen;
		len -= dmalen;
	}
	AdpcmoutMain(0x00,mode,len,dmaadrs);
}

// IOCS _ADPCMAOT ($62) ̏
// []
//   struct _chain *tbl : AC`FCe[ũAhX
//   int mode : TvOg(0`4)*256+PAN(0`3)
//   int cnt : AC`FCe[ũubN
void X68SoundIOCS::adpcmaot(struct _chain *tbl, int mode, int cnt) {
	while (AdpcmStat);	// DMA]I҂

	AdpcmStat = 0x12;
	X68Sound::DmaPoke(0x05, 0x3A);	// DMA OCR AC`FCɐݒ

	X68Sound::DmaPoke(0x00, 0xFF);	// DMA CSR ̑SrbgNA
	DmaPokeL(0x1C, tbl);	// DMA BAR ɃAC`FCe[uAhXZbg
	DmaPokeW(0x1A, cnt);	// DMA BTC ɃAC`FCe[ǔZbg
	SetAdpcmMode(mode, 0x88);	// TvOgPANݒ肵DMA]Jn

	X68Sound::AdpcmPoke(0x02);	// ADPCMĐJn
}

// IOCS _ADPCMAOT ($64) ̏
// []
//   struct _chain2 *tbl : NAC`FCe[ũAhX
//   int mode : TvOg(0`4)*256+PAN(0`3)
void X68SoundIOCS::adpcmlot(struct _chain2 *tbl, int mode) {
	while (AdpcmStat);	// DMA]I҂

	AdpcmStat = 0x22;
	X68Sound::DmaPoke(0x05, 0x3E);	// DMA OCR NAC`FCɐݒ

	X68Sound::DmaPoke(0x00, 0xFF);	// DMA CSR ̑SrbgNA
	DmaPokeL(0x1C, tbl);	// DMA BAR ɃNAC`FCe[uAhXZbg
	SetAdpcmMode(mode, 0x88);	// TvOgPANݒ肵DMA]Jn

	X68Sound::AdpcmPoke(0x02);	// ADPCMĐJn
}


// ReBj[[h𗘗pADPCMo͂sTv
// IOCS _ADPCMOUT ƓsAf[^oCg0xFF00oCgȏł
// Ƀ^[B
// []
//   void *addr : ADPCMf[^AhX
//   int mode : TvOg(0`4)*256+PAN(0`3)
//   int len : ADPCMf[^̃oCg
void X68SoundIOCS::adpcmcot(void *addr, int mode, int len) {
	int dmalen;
	Adpcmcot_adrs = (unsigned char *)addr;
	Adpcmcot_len = len;
	while (AdpcmStat);	// DMA]I҂
	AdpcmStat = 0x32;

	X68Sound::DmaPoke(0x05, 0x32);	// DMA OCR `FCȂɐݒ

	dmalen = Adpcmcot_len;
	if (dmalen > 0xFF00) {	// ADPCMf[^0xFF00oCgȏ̏ꍇ
		dmalen = 0xFF00;	// 0xFF00oCgɕDMA]s
	}

	X68Sound::DmaPoke(0x00, 0xFF);	// DMA CSR ̑SrbgNA
	DmaPokeL(0x0C, Adpcmcot_adrs);	// DMA MAR DMA]AhXZbg
	DmaPokeW(0x0A, dmalen);	// DMA MTC DMA]oCgZbg
	Adpcmcot_adrs += dmalen;
	Adpcmcot_len -= dmalen;
	if (Adpcmcot_len <= 0) {
		SetAdpcmMode(mode, 0x88);	// f[^oCg0xFF00ȉ̏ꍇ͒ʏ]
	} else {
		dmalen = Adpcmcot_len;
		if (dmalen > 0xFF00) {
			dmalen = 0xFF00;
		}
		DmaPokeL(0x1C, Adpcmcot_adrs);	// BARɎDMA]AhXZbg
		DmaPokeW(0x1A, dmalen);	// BTCɎDMA]oCgZbg
		Adpcmcot_adrs += dmalen;
		Adpcmcot_len -= dmalen;
		SetAdpcmMode(mode, 0xC8);	// DMA CNTrbg1ɂDMA]Jn
	}

	X68Sound::AdpcmPoke(0x02);	// ADPCMĐJn
}

// IOCS _ADPCMSNS ($66) ̏
// [߂l]
//   0 : ĂȂ
//   $02 : X68SoundIOCS::adpcmout ŏo͒
//   $12 : X68SoundIOCS::adpcmaot ŏo͒
//   $22 : X68SoundIOCS::adpcmlot ŏo͒
//   $32 : X68SoundIOCS::adpcmcot ŏo͒
int X68SoundIOCS::adpcmsns() {
	return (AdpcmStat&0x7F);
}

// IOCS _ADPCMMOD ($67) ̏
// []
//   0 : ADPCMĐ I
//   1 : ADPCMĐ ꎞ~
//   2 : ADPCMĐ ĊJ
void X68SoundIOCS::adpcmmod(int mode) {
	switch (mode) {
	case 0:
		AdpcmStat = 0;
		X68Sound::PpiCtrl(0x01);	// ADPCMEoOFF
		X68Sound::PpiCtrl(0x03);	// ADPCMoOFF
		X68Sound::AdpcmPoke(0x01);	// ADPCMĐ~
		X68Sound::DmaPoke(0x07, 0x10);	// DMA SAB=1 (\tgEFAA{[g)
		break;
	case 1:
		X68Sound::DmaPoke(0x07, 0x20);	// DMA HLT=1 (zgIy[V)
		break;
	case 2:
		X68Sound::DmaPoke(0x07, 0x08);	// DMA HLT=0 (zgIy[V)
		break;
	}
}


// IOCSR[̏
// DMÅ荞݂ݒ肷
X68SoundIOCS::X68SoundIOCS()
{
	AdpcmStat = 0; // $02:adpcmout $12:adpcmaot $22:adpcmlot $32:adpcmcot
	OpmReg1B = 0;  // OPM WX^ $1B ̓e
	DmaErrCode = 0;
	OpmIntProc = NULL;	// OPM̃^C}[荞ݏAhX
	OpmIntPara = 0;
}

X68SoundIOCS::~X68SoundIOCS()
{
}

int X68SoundIOCS::StartPcm(int samprate, int opmflag, int adpcmflag, int pcmbuf, bool lpf)
{
	int ret;
	ret = X68Sound::StartPcm(samprate, opmflag, adpcmflag, pcmbuf, lpf);
	if (!ret)
	{
		X68Sound::DmaInt(::DmaIntProc, (void *)this);
		X68Sound::DmaErrInt(::DmaErrIntProc, (void *)this);
	}
	return ret;
}
