#define	MAXPCMVAL	(2047)

class Adpcm {
	OpmCommonWork *pcw;
	int	Scale;		// 
	int Pcm;		// 16bit PCM Data
	int InpPcm,InpPcm_prev,OutPcm;		// HPFp 16bit PCM Data
	int OutInpPcm,OutInpPcm_prev;		// HPFp
	volatile int	AdpcmRate;	// 187500(15625*12), 125000(10416.66*12), 93750(7812.5*12), 62500(5208.33*12), 46875(3906.25*12), ...
	int	RateCounter;
	int	N1Data;	// ADPCM 1Tṽf[^̕ۑ
	int N1DataFlag;	// 0 or 1

// adpcm͂ InpPcm ̒lω
// -2047<<(4+4) <= InpPcm <= +2047<<(4+4)
inline void adpcm2pcm(unsigned char adpcm) {

	
	int	dltL;
	dltL = dltLTBL[Scale];
	dltL = (dltL&(adpcm&4?-1:0)) + ((dltL>>1)&(adpcm&2?-1:0)) + ((dltL>>2)&(adpcm&1?-1:0)) + (dltL>>3);
	int sign = adpcm&8?-1:0;
	dltL = (dltL^sign)+(sign&1);
	Pcm += dltL;
	

	if ((unsigned int)(Pcm+MAXPCMVAL) > (unsigned int)(MAXPCMVAL*2)) {
		if ((int)(Pcm+MAXPCMVAL) >= (int)(MAXPCMVAL*2)) {
			Pcm = MAXPCMVAL;
		} else {
			Pcm = -MAXPCMVAL;
		}
	}

	InpPcm = (Pcm&(int)0xFFFFFFFC)<<(4+4);

	Scale += DCT[adpcm];
	if ((unsigned int)Scale > (unsigned int)48) {
		if ((int)Scale >= (int)48) {
			Scale = 48;
		} else {
			Scale = 0;
		}
	}
}

public:
	void (CALLBACK *IntProc)(void *);	// 荞݃AhX
	void *IntPara;
	void (CALLBACK *ErrIntProc)(void *);	// 荞݃AhX
	void *ErrIntPara;
//	int	AdpcmFlag;	// 0:񓮍  1:Đ
//	int PpiReg;		// PPI WX^̓e
//	int	DmaCsr;		// DMA CSR WX^̓e
//	int	DmaCcr;		// DMA CCR WX^̓e
//	int	DmaFlag;	// 0:DMA񓮍  1:DMA쒆
	unsigned char	DmaLastValue;
	volatile unsigned char	AdpcmReg;
	volatile unsigned char	DmaReg[0x40];
	int FinishCounter;



Adpcm() {}
~Adpcm() {}

inline void SetCW(OpmCommonWork *pcwp) {
	pcw = pcwp;
}

inline void SetAdpcmRate(int rate) {
	AdpcmRate = ADPCMRATEADDTBL[rate & 7];
}

inline void Init() {
	Scale = 0;
	Pcm = 0;
	InpPcm = InpPcm_prev = OutPcm = 0;
	OutInpPcm = OutInpPcm_prev = 0;
	AdpcmRate = 15625*12;
	RateCounter = 0;
	N1Data = 0;
	N1DataFlag = 0;
	IntProc = NULL;
	IntPara = NULL;
	ErrIntProc = NULL;
	ErrIntPara = NULL;
	DmaLastValue = 0;
	AdpcmReg = 0xC7;
	{
		int i;
		for (i=0; i<0x40; ++i) {
			DmaReg[i] = DmaRegInit[i];
		}
	}
	FinishCounter = 3;
}
inline void InitSamprate() {
	RateCounter = 0;
}
inline void Reset() {	// ADPCM L[Ȉ

	Scale = 0;

	Pcm = 0;
	InpPcm = InpPcm_prev = OutPcm = 0;
	OutInpPcm = OutInpPcm_prev = 0;

	N1Data = 0;
	N1DataFlag = 0;


}


inline void DmaError(unsigned char errcode) {
	DmaReg[0x00] &= 0xF7;		// ACT=0
	DmaReg[0x00] |= 0x90;		// COC=ERR=1
	DmaReg[0x01] = errcode;		// CER=errorcode
	if (DmaReg[0x07] & 0x08) {	// INT==1?
		if (ErrIntProc != NULL) {
			ErrIntProc(ErrIntPara);
		}
	}
}
inline void DmaFinish() {
	DmaReg[0x00] &= 0xF7;		// ACT=0
	DmaReg[0x00] |= 0x80;		// COC=1
	if (DmaReg[0x07] & 0x08) {	// INT==1?
		if (IntProc != NULL) {
			IntProc(IntPara);
		}
	}
}

inline int DmaContinueSetNextMtcMar() {
	DmaReg[0x07] &= (0xFF-0x40);	// CNT=0
	*(unsigned short *)&DmaReg[0x0A] = *(unsigned short *)&DmaReg[0x1A];	// BTC -> MTC
	*(unsigned int *)&DmaReg[0x0C] = *(unsigned int *)&DmaReg[0x1C];	// BAR -> MAR
	DmaReg[0x29] = DmaReg[0x39];	// BFC -> MFC
	if ( (*(unsigned short *)&DmaReg[0x0A]) == 0 ) {	// MTC == 0 ?
		DmaError(0x0D);	// JEgG[(AhX/JE^)
		return 1;
	}
	DmaReg[0x00] |= 0x40;		// BTC=1
	if (DmaReg[0x07] & 0x08) {	// INT==1?
		if (IntProc != NULL) {
			IntProc(IntPara);
		}
	}
	return 0;
}
inline int DmaArrayChainSetNextMtcMar() {
	unsigned short	Btc;
	Btc = bswapw(*(unsigned short *)&DmaReg[0x1A]);
	if ( Btc == 0 ) {
		DmaFinish();
		FinishCounter = 0;
		return 1;
	}
	--Btc;
	*(unsigned short *)&DmaReg[0x1A] = bswapw(Btc);

	unsigned char *Bar;
	Bar = bswapl(*(unsigned char **)&DmaReg[0x1C]);
	int	mem0,mem1,mem2,mem3,mem4,mem5;
	mem0 = pcw->MemRead(Bar++);
	mem1 = pcw->MemRead(Bar++);
	mem2 = pcw->MemRead(Bar++);
	mem3 = pcw->MemRead(Bar++);
	mem4 = pcw->MemRead(Bar++);
	mem5 = pcw->MemRead(Bar++);
	if ((mem0|mem1|mem2|mem3|mem4|mem5) == -1) {
		DmaError(0x0B);		// oXG[(x[XAhX/x[XJE^)
		return 1;
	} 
	*(unsigned char **)&DmaReg[0x1C] = bswapl(Bar);
	DmaReg[0x0C] = mem0;	// MAR
	DmaReg[0x0D] = mem1;
	DmaReg[0x0E] = mem2;
	DmaReg[0x0F] = mem3;
	DmaReg[0x0A] = mem4;	// MTC
	DmaReg[0x0B] = mem5;

	if ( (*(unsigned short *)&DmaReg[0x0A]) == 0 ) {	// MTC == 0 ?
		DmaError(0x0D);		// JEgG[(AhX/JE^)
		return 1;
	}
	return 0;
}
inline int DmaLinkArrayChainSetNextMtcMar() {
	unsigned char *Bar;
	Bar = bswapl(*(unsigned char **)&DmaReg[0x1C]);
	if (Bar == (unsigned char *)0) {
		DmaFinish();
		FinishCounter = 0;
		return 1;
	}

	int	mem0,mem1,mem2,mem3,mem4,mem5;
	int mem6,mem7,mem8,mem9;
	mem0 = pcw->MemRead(Bar++);
	mem1 = pcw->MemRead(Bar++);
	mem2 = pcw->MemRead(Bar++);
	mem3 = pcw->MemRead(Bar++);
	mem4 = pcw->MemRead(Bar++);
	mem5 = pcw->MemRead(Bar++);
	mem6 = pcw->MemRead(Bar++);
	mem7 = pcw->MemRead(Bar++);
	mem8 = pcw->MemRead(Bar++);
	mem9 = pcw->MemRead(Bar++);
	if ((mem0|mem1|mem2|mem3|mem4|mem5|mem6|mem7|mem8|mem9) == -1) {
		DmaError(0x0B);		// oXG[(x[XAhX/x[XJE^)
		return 1;
	} 
	*(unsigned char **)&DmaReg[0x1C] = bswapl(Bar);
	DmaReg[0x0C] = mem0;	// MAR
	DmaReg[0x0D] = mem1;
	DmaReg[0x0E] = mem2;
	DmaReg[0x0F] = mem3;
	DmaReg[0x0A] = mem4;	// MTC
	DmaReg[0x0B] = mem5;
	DmaReg[0x1C] = mem6;	// BAR
	DmaReg[0x1D] = mem7;
	DmaReg[0x1E] = mem8;
	DmaReg[0x1F] = mem9;

	if ( (*(unsigned short *)&DmaReg[0x0A]) == 0 ) {	// MTC == 0 ?
		DmaError(0x0D);		// JEgG[(AhX/JE^)
		return 1;
	}
	return 0;
}

inline int	DmaGetByte() {
	if ((!(DmaReg[0x00]&0x08)) || (DmaReg[0x07]&0x20)) {	// ACT==0 || HLT==1 ?
		return 0x80000000;
	}
	unsigned short	Mtc;
	Mtc = bswapw(*(unsigned short *)&DmaReg[0x0A]);
	if (Mtc == 0) {
//		if (DmaReg[0x07] & 0x40) {	// Continue
//			if (DmaContinueSetNextMtcMar()) {
//				return 0x80000000;
//			}
//			Mtc = bswapw(*(unsigned short *)&DmaReg[0x0A]);
//		} else {
			return 0x80000000;
//		}
	}
	
	
	{
		unsigned char *Mar;
		Mar = bswapl(*(unsigned char **)&DmaReg[0x0C]);
		int mem;
		mem = pcw->MemRead(Mar);
		if (mem == -1) {
			DmaError(0x09);	// oXG[(AhX/JE^)
			return 0x80000000;
		}
		DmaLastValue = mem;
		Mar += MACTBL[(DmaReg[0x06]>>2)&3];
		*(unsigned char **)&DmaReg[0x0C] = bswapl(Mar);
	}

	--Mtc;
	*(unsigned short *)&DmaReg[0x0A] = bswapw(Mtc);

	do {
	if (Mtc == 0) {
		if (DmaReg[0x07] & 0x40) {	// Continue
			if (DmaContinueSetNextMtcMar()) {
				break;
			}
		} else if (DmaReg[0x05] & 0x08) {	// `FCjO
			if (!(DmaReg[0x05] & 0x04)) {	// AC`FC
				if (DmaArrayChainSetNextMtcMar()) {
					break;
				}
			} else {						// NAC`FC
				if (DmaLinkArrayChainSetNextMtcMar()) {
					break;
				}
			}
		} else {	// m[}]I
//			if (!(DmaReg[0x00] & 0x40)) {		// BTC=1 ?
//				if (DmaContinueSetNextMtcMar()) {
//					break;
//				}
//			} else {
				DmaFinish();
				FinishCounter = 0;
//			}
		}
	}
	} while(0);
	
	return DmaLastValue;
}









// -32768<<4 <= retval <= +32768<<4
inline int GetPcm() {
	if (AdpcmReg & 0x80) {		// ADPCM ~
		return 0x80000000;
	}
	RateCounter -= AdpcmRate;
	while (RateCounter < 0) {
		int	N10Data;	// (N1Data << 4) | N0Data
		if (N1DataFlag == 0) {		// ADPCMf[^ɂȂꍇ
			N10Data = DmaGetByte();	// DMA](1oCg)
			if (N10Data == 0x80000000) {
				RateCounter = 0;
				return 0x80000000;
			}
			adpcm2pcm(N10Data & 0x0F);	// InpPcm ɒl
			N1Data = (N10Data >> 4) & 0x0F;
			N1DataFlag = 1;
		} else {
			adpcm2pcm(N1Data);			// InpPcm ɒl
			N1DataFlag = 0;
		}
		RateCounter += 15625*12;
	}
	OutPcm = ((InpPcm<<9) - (InpPcm_prev<<9) + 459*OutPcm) >> 9;
	InpPcm_prev = InpPcm;

	return (OutPcm*pcw->TotalVolume)>>8;
}

// -32768<<4 <= retval <= +32768<<4
inline int GetPcm62() {
	if (AdpcmReg & 0x80) {		// ADPCM ~
		return 0x80000000;
	}
	RateCounter -= AdpcmRate;
	while (RateCounter < 0) {
		int	N10Data;	// (N1Data << 4) | N0Data
		if (N1DataFlag == 0) {		// ADPCMf[^ɂȂꍇ
			N10Data = DmaGetByte();	// DMA](1oCg)
			if (N10Data == 0x80000000) {
				RateCounter = 0;
				return 0x80000000;
			}
			adpcm2pcm(N10Data & 0x0F);	// InpPcm ɒl
			N1Data = (N10Data >> 4) & 0x0F;
			N1DataFlag = 1;
		} else {
			adpcm2pcm(N1Data);			// InpPcm ɒl
			N1DataFlag = 0;
		}
		RateCounter += 15625*12*4;

	}
	OutInpPcm = (InpPcm<<9) - (InpPcm_prev<<9) +  OutInpPcm-(OutInpPcm>>5)-(OutInpPcm>>10);
	InpPcm_prev = InpPcm;
	OutPcm = OutInpPcm - OutInpPcm_prev + OutPcm-(OutPcm>>8)-(OutPcm>>9)-(OutPcm>>12);
	OutInpPcm_prev = OutInpPcm;
	return (OutPcm>>9);
}


};
