#include "../depend.h"
#include "X68sound.h"
#include "opm.h"

X68Sound::X68Sound()
{
	popm = 0;
}
X68Sound::~X68Sound()
{
	Free();
}

int X68Sound::StartPcm(int samprate, int opmflag, int adpcmflag, int pcmbuf, bool lpf) {
	popm = new Opm;
	if (!popm) return X68Sound::ERR_MEMORY;
	return popm->StartPcm(samprate, opmflag, adpcmflag, pcmbuf, lpf);
}
void X68Sound::Free() {
	if (popm)
	{
		popm->Free();
		delete popm;
		popm = 0;
	}
}
int X68Sound::GetPcm(void *buf, int len) {
	return popm->GetPcm(buf, len);
}
int X68Sound::TotalVolume(int v) {
	return popm->SetTotalVolume(v);
}
int X68Sound::OpmWait(int wait) {
	return popm->SetOpmWait(wait);
}
unsigned char X68Sound::OpmPeek() {
	return popm->OpmPeek();
}
void X68Sound::OpmPoke(unsigned char data) {
	popm->OpmPoke(data);
}
void X68Sound::OpmReg(unsigned char no) {
	popm->OpmReg(no);
}
void X68Sound::OpmInt(void (CALLBACK *proc)(void *), void *para) {
	popm->OpmInt(proc, para);
}
unsigned char X68Sound::DmaPeek(unsigned char adrs) {
	return popm->DmaPeek(adrs);
}
void X68Sound::DmaPoke(unsigned char adrs, unsigned char data) {
	popm->DmaPoke(adrs, data);
}
void X68Sound::DmaInt(void (CALLBACK *proc)(void *), void *para) {
	popm->DmaInt(proc, para);
}
void X68Sound::DmaErrInt(void (CALLBACK *proc)(void *), void *para) {
	popm->DmaErrInt(proc, para);
}
unsigned char X68Sound::PpiPeek() {
	return popm->PpiPeek();
}
void X68Sound::PpiPoke(unsigned char data) {
	popm->PpiPoke(data);
}
void X68Sound::PpiCtrl(unsigned char data) {
	popm->PpiCtrl(data);
}
unsigned char X68Sound::AdpcmPeek() {
	return popm->AdpcmPeek();
}
void X68Sound::AdpcmPoke(unsigned char data) {
	popm->AdpcmPoke(data);
}
int X68Sound::Pcm8_Out(int ch, void *adrs, int mode, int len) {
	return popm->Pcm8_Out(ch, adrs, mode, len);
}
int X68Sound::Pcm8_Abort() {
	return popm->Pcm8_Abort();
}






#if 0

int X68Sound::Start(int samprate, int opmflag, int adpcmflag,
				  int betw, int pcmbuf, int late, double rev) {
	return popm->Start(samprate, opmflag, adpcmflag, betw, pcmbuf, late, rev);
}
int X68Sound::Samprate(int samprate) {
	return popm->SetSamprate(samprate);
}
int X68Sound::OpmClock(int clock) {
	return popm->SetOpmClock(clock);
}
void X68Sound::Reset() {
	popm->Reset();
}
void X68Sound::BetwInt(void (CALLBACK *proc)()) {
	popm->BetwInt(proc);
}

void X68Sound::MemReadFunc(int (CALLBACK *func)(unsigned char *)) {
	popm->MemReadFunc(func);
}

void X68Sound::WaveFunc(int (CALLBACK *func)()) {
	popm->SetWaveFunc(func);
}

int X68Sound::Pcm8_Aot(int ch, void *tbl, int mode, int cnt) {
	return popm->Pcm8_Aot(ch, tbl, mode, cnt);
}
int X68Sound::Pcm8_Lot(int ch, void *tbl, int mode) {
	return popm->Pcm8_Lot(ch, tbl, mode);
}
int X68Sound::Pcm8_SetMode(int ch, int mode) {
	return popm->Pcm8_SetMode(ch, mode);
}
int X68Sound::Pcm8_GetRest(int ch) {
	return popm->Pcm8_GetRest(ch);
}
int X68Sound::Pcm8_GetMode(int ch) {
	return popm->Pcm8_GetMode(ch);
}

int X68Sound::ErrorCode() {
	return ErrorCode;
}
int X68Sound::DebugValue() {
	return DebugValue;
}
#endif
