class Opm;

class X68Sound {
public:
	enum {
		ERR_PCMOUT	=(-1),
		ERR_TIMER		=(-2),
		ERR_MEMORY	=(-3),
		ERR_NOTACTIVE	=(-4),
		ERR_ALREADYACTIVE	=(-5),
		ERR_BADARG	=(-6),

		ERR_DLL		=(-1),
		ERR_FUNC		=(-2)
	};
	X68Sound();
	~X68Sound();

	int StartPcm(int samprate=44100, int opmflag=1, int adpcmflag=1, int pcmbuf=5, bool lpf = true);
	void Free();
	int GetPcm(void *buf, int len);
	int TotalVolume(int v);
	int OpmWait(int wait=240);
	unsigned char OpmPeek();
	void OpmPoke(unsigned char data);
	void OpmReg(unsigned char no);
	void OpmInt(void (CALLBACK *proc)(void *)=NULL, void *para=NULL);
	unsigned char DmaPeek(unsigned char adrs);
	void DmaPoke(unsigned char adrs, unsigned char data);
	void DmaInt(void (CALLBACK *proc)(void *)=NULL, void *para=NULL);
	void DmaErrInt(void (CALLBACK *Proc)(void *)=NULL, void *para=NULL);
	unsigned char PpiPeek();
	void PpiPoke(unsigned char data);
	void PpiCtrl(unsigned char data);
	unsigned char AdpcmPeek();
	void AdpcmPoke(unsigned char data);
	int Pcm8_Out(int ch, void *adrs, int mode, int len);
	int Pcm8_Abort();

#if 0
extern "C" int X68Sound_Start(int samprate=44100, int opmflag=1, int adpcmflag=1,
				  int betw=5, int pcmbuf=5, int late=200, double rev=1.0);
extern "C" int X68Sound_Samprate(int samprate=44100);
extern "C" void X68Sound_Reset();
extern "C" void X68Sound_BetwInt(void (CALLBACK *proc)()=NULL);
extern "C" int X68Sound_OpmClock(int clock=4000000);
extern "C" void X68Sound_MemReadFunc(int (CALLBACK *func)(unsigned char *)=NULL);
extern "C" void X68Sound_WaveFunc(int (CALLBACK *func)()=NULL);
extern "C" int X68Sound_Pcm8_Aot(int ch, void *tbl, int mode, int cnt);
extern "C" int X68Sound_Pcm8_Lot(int ch, void *tbl, int mode);
extern "C" int X68Sound_Pcm8_SetMode(int ch, int mode);
extern "C" int X68Sound_Pcm8_GetRest(int ch);
extern "C" int X68Sound_Pcm8_GetMode(int ch);
extern "C" int X68Sound_ErrorCode();
extern "C" int X68Sound_DebugValue();
#endif

protected:
	Opm *popm;
};
